//
//  ColorTriangle.m
//  IFS3D
//
//  Copyright (c) 2001 David Leppik.
//

#import "ColorTriangle.h"


@implementation ColorTriangle

/** If YES, this shape has a left-eye and right-eye mode */
- (BOOL)isStereo { return NO; }

/** IFS3D_LEFT or IFS3D_RIGHT */
- (void)setEye:(enum ViewerEye)newEye {}
- (enum ViewerEye)getEye { return NEITHER; }

/** Call callGLParams and set view-specific GL settings */
- (void)setView:(id)view { [self callGlParams]; }

/** Enable or disable render settings for the shape */
- (void)callGlParams {
    glEnable(GL_DEPTH_TEST);
    
    glDisable(GL_BLEND);
    glDisable(GL_LINE_SMOOTH);
    glDisable(GL_POINT_SMOOTH);
    glDisable(GL_POLYGON_SMOOTH);
    
    glDisable(GL_CULL_FACE);
    glDisable(GL_LIGHTING);
}

/** Set color, pen width, etc. changes before drawing. */
- (void)prepareToDraw {
    glPointSize(1);
}

- (void)draw3D {

        glBegin( GL_TRIANGLES );
            glColor4f( 1, 0, 0, 1.0 );	glVertex3f( 0.0, 0.5, 0.0 );
            glColor4f( 0, 1, 0, 1.0 );	glVertex3f( 1.0, 0.0, 0.0 );
            glColor4f( 0, 0, 1, 1.0 );	glVertex3f( 0.0,-0.5, 0.0 );
        glEnd();
        glBegin( GL_POINTS );
            glColor4f( 1, 0, 0, 1.0 );	glVertex3f( 0.0, 0.5, 0.0 );
            glColor4f( 0, 1, 0, 1.0 );	glVertex3f( 1.0, 0.0, 0.0 );
            glColor4f( 0, 0, 1, 1.0 );	glVertex3f( 0.0,-0.5, 0.0 );
        glEnd();
}
@end
