//
//  IFS3DDefaults.h
//  IFS3D
//
//  Copyright (c) 2001 David Leppik.
//

// Back-end handling of the defaults.  Bigger and kludgier than it needs to be.

#import <Foundation/Foundation.h>

#import "Shape.h"

@class IFS3D;

#define MAX_BRANCHES	8

@interface IFS3DDefaults : NSObject {
    IFS3D *fractal;
    NSMutableDictionary *defaults;
}

/** Factory method, use instead of constructor */
+ (id)sharedInstance;

//------------------------------------------------------------------------------------
//  Saving and reverting
//------------------------------------------------------------------------------------

+(NSDictionary *)factoryDefaults;

/** Set all values to the original defaults */
- (void)useFactoryDefaults;

/** Set all values to saved values */
- (void)load;

- (BOOL)save;


//------------------------------------------------------------------------------------
//  Getters and setters.
//  The fractal is updated automatically when values are changed.
//------------------------------------------------------------------------------------

- (id)objectForKey:(id)key;
- (void)setObject:(id)value forKey:(id)key;


- (BOOL)boolForKey:(id)key;
- (void)setBool:(BOOL)value forKey:(id)key;

- (int)intForKey:(id)key;
- (void)setInt:(int)value forKey:(id)key;

- (float)floatForKey:(id)key;
- (void)setFloat:(float)value forKey:(id)key;


- (IFS3D *)fractal;

//------------------------------------------------------------------------------------
//  Utilities
//------------------------------------------------------------------------------------

+(id <Shape>)shapeForName:(NSString *)name;

@end
