//
//  IFS3DPreferences.h
//  IFS3D
//
//  Copyright (c) 2001 David Leppik.
//

// This controls the preferences panel.  It doesn't handle the defaults.

#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>

@class IFS3D;

@interface IFS3DPreferences : NSWindowController {

    IBOutlet NSButton *flatCheckbox;
    IBOutlet NSButton *largePointCheckbox;
    
    IBOutlet NSSlider *iterationsSlider;
    IBOutlet NSSlider *complexitySlider;
    IBOutlet NSTextField *shapeCountTextField;
    IBOutlet NSTextField *stepsCountTextField;

    IBOutlet NSMatrix *shapeMatrix;

    IBOutlet NSSlider *rotationSpeedSlider;
    IBOutlet NSSlider *fractalSpeedSlider;
    
    IBOutlet NSPopUpButton * reflectionsPopUpButton;

    IBOutlet NSSlider *separationSlider;
    
    IBOutlet NSButton *okButton;
}

+ (id)sharedInstance;

- (IBAction)iterationsSliderAction:(id)sender;
- (IBAction)complexitySliderAction:(id)sender;

/** returns NO iff the complexity is calculated to be greater than INT_MAX */
- (BOOL)refreshShapeCount;

- (IBAction)flatCheckboxAction:(id)sender;
- (IBAction)largePointCheckboxAction:(id)sender;

- (IBAction)shapeSelection:(id)sender;

- (IBAction)okButtonAction:(id)sender;
- (IBAction)revertButtonAction:(id)sender;
- (IBAction)resetButtonAction:(id)sender;

- (IBAction)rotationSpeedAction:(id)sender;
- (IBAction)fractalSpeedAction:(id)sender;

- (IBAction)separationAction:(id)sender;

- (IBAction)reflectionsAction:(id)sender;


@end

