//
//  PointShape.m
//  IFS3D
//
//  Copyright (c) 2001 David Leppik.
//

#import "PointShape.h"
#import "IFS3DDefaults.h"


@implementation PointShape

/** If YES, this shape has a left-eye and right-eye mode */
- (BOOL)isStereo { return NO; }

/** IFS3D_LEFT or IFS3D_RIGHT */
- (void)setEye:(enum ViewerEye)newEye {}
- (enum ViewerEye)getEye { return NEITHER; }

/** Call callGLParams and set view-specific GL settings */
- (void)setView:(id)view { [self callGlParams]; }

/** Enable or disable render settings for the shape */
- (void)callGlParams {
    glDisable(GL_DEPTH_TEST);
    
    glDisable(GL_BLEND);
    glDisable(GL_LINE_SMOOTH);
    glDisable(GL_POINT_SMOOTH);
    glDisable(GL_POLYGON_SMOOTH);
    
    glDisable(GL_CULL_FACE);
    glDisable(GL_LIGHTING);
}

/** Set color, pen width, etc. changes before drawing. */
- (void)prepareToDraw {
    if ([[IFS3DDefaults sharedInstance] boolForKey:@"fractal.largePoint"]) {
        glPointSize(LARGE_POINT_SIZE);
    }
    else {
        glPointSize(1);
    }
    glColor4f(1,1,1,1);
}


- (void)draw3D {    
    glBegin( GL_POINTS );
        glVertex3f( 0.0, 0.0, 0.0 );
    glEnd();
}
@end
