//
//  Shape.h
//  IFS3D
//
//  Copyright (c) 2001 David Leppik.
//

#import <OpenGL/gl.h>
#import <OpenGL/glu.h>
#import <Cocoa/Cocoa.h>

#define LARGE_POINT_SIZE	3

enum ViewerEye { NEITHER, LEFT, RIGHT };

@protocol Shape

/** If YES, this shape has a left-eye and right-eye mode */
- (BOOL)isStereo;

/** IFS3D_LEFT or IFS3D_RIGHT */
- (void)setEye:(enum ViewerEye)newEye;
- (enum ViewerEye)getEye;


/** Call callGLParams and set view-specific GL settings.
 *  This should be called before calling prepareToDraw.
 */
- (void)setView:(id)view;

/** Enable or disable render settings for the shape */
- (void)callGlParams;

/** Set color, pen width, etc. changes before drawing. */
- (void)prepareToDraw;

/** Draw the shape in the current OpenGL environment */
- (void)draw3D;
@end

