//
//  Sphere.m
//  IFS3D
//
//  Copyright (c) 2001 David Leppik.
//

#import "Sphere.h"


@implementation Sphere

-(id)init {
    self = [super init];
    if (self) {
        quadratic = gluNewQuadric();
    }
    return self;
}

/** If YES, this shape has a left-eye and right-eye mode */
- (BOOL)isStereo { return NO; }

/** IFS3D_LEFT or IFS3D_RIGHT */
- (void)setEye:(enum ViewerEye)newEye {}
- (enum ViewerEye)getEye { return NEITHER; }

/** Call callGLParams and set view-specific GL settings */
- (void)setView:(id)view { 
    [self callGlParams];
    gluDeleteQuadric(quadratic);
    quadratic = gluNewQuadric();
}


/** Enable or disable render settings for the shape */
- (void)callGlParams {
    glEnable(GL_DEPTH_TEST);
    
    glDisable(GL_BLEND);
    glDisable(GL_LINE_SMOOTH);
    glDisable(GL_POINT_SMOOTH);
    glDisable(GL_POLYGON_SMOOTH);
    
    glEnable(GL_CULL_FACE);
    
    glEnable(GL_LIGHTING);
    glShadeModel(GL_SMOOTH);
    glEnable(GL_COLOR_MATERIAL);
    glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);
    
    glEnable(GL_LIGHT0);
}

/** Set color, pen width, etc. changes before drawing. */
- (void)prepareToDraw {
    glPointSize(1);
    glColor4f( 1, 1, 0, 1 );
}

- (void)draw3D {
    //gluQuadricDrawStyle(quadratic, GLU_SILHOUETTE);
    gluSphere( quadratic, 2.0, 7, 7 );
}

- (void)dealloc {
    gluDeleteQuadric(quadratic);
}

@end
